---
category: blog
date:   2021-02-08 17:14:08 +0700
lang: en
translationKey: "first-name-last-name"
tags: [name, culture, inclusion, awareness]
title:  "Enough for first name/last name BS"
---

I keep seeing registration where I have to input my "First name" and my "Last name".
What's the point? Isn't the user's full name just enough, if it's even needed?

# Why you should avoid that

It's blatantly ignorant!

It assumes one must have a first name and last name to begin with.
It is not the case for some country, such as Indonesia, where one can have
just one name (also known as "mononym"). How are they supposed to fill your form?

Those who do this often assume that given name (i.e. "first name") always comes first,
and family name (i.e. "last name") comes last and display as such without asking.
In many Asian countries, like China, Vietnam, or Korea,
given name comes after family name. They also do this in Hungary.
When they allow changing name order, they add a comma in between, also without asking.

It is also not universally agreed upon where the middle names should go to.
This is not a problem when the full name is not required (e.g. Facebook or Google account)
but when full name is required (e.g. my school G-Suite account or for IELTS registration),
it is problematic how they represent my name. A few lecturers whom I'm not close with
keep referring to me by my middle name due to how Google displays my name.

# Who do this?

- Many web services, e.g. Facebook, Google, LinkedIn
- Language certification tests: IELTS, TCF, DELF/DALF, ...

# Proposed alternative

- Just ask for full name. Governments do that and they're fine.
- Ask how users want to be referred as, don't assume.
  I never want to be referred by my family name.
- Maybe avoid asking for real name at the first place
  if you're just some online service. [Real name policy][real-name-bad] harms social network users.
  Even Google dropped that BS.

[real-name-bad]: https://stallman.org/facebook.html#realname
